## h10-pyhailort 5.1.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5.0)

find_program(CCACHE_PROGRAM ccache)
find_program(CLACHE_PROGRAM clcache)

if(CCACHE_PROGRAM)
    set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE "${CCACHE_PROGRAM}")
elseif(CLCACHE_PROGRAM)
    set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE "${CLCACHE_PROGRAM}")
endif()

if(WIN32)
    find_program(SCCACHE sccache)
    if(SCCACHE)
        set(CMAKE_C_COMPILER_LAUNCHER ${SCCACHE})
        set(CMAKE_CXX_COMPILER_LAUNCHER ${SCCACHE})
        set(CMAKE_MSVC_DEBUG_INFORMATION_FORMAT Embedded)
        cmake_policy(SET CMP0141 NEW)
    endif()
endif()

project(HailoRT)

# Prevent in-tree building
if("${CMAKE_SOURCE_DIR}" STREQUAL "${CMAKE_BINARY_DIR}")
    message(FATAL_ERROR "In-source builds are not allowed.
    Please remove the `CMakeCache.txt` file and `CMakeFiles` directory from `${CMAKE_SOURCE_DIR}`
    In order to build, please create a new `build` directory and run `cmake ..` from there.")
endif()

# Set compiler flags in HAILORT_COMPILE_OPTIONS
# TODO: Change HAILORT_COMPILE_OPTIONS to add_compile_options
if(WIN32)
    # TODO: set this eventually? set(HAILORT_COMPILE_OPTIONS /Wall)
    set(HAILORT_COMPILE_OPTIONS ${HAILORT_COMPILE_OPTIONS}
        /W4
        /DWIN32_LEAN_AND_MEAN
        /DNOMINMAX                  # NOMINMAX is required in order to play nice with std::min/std::max (otherwise Windows.h defines it's own)
        /D_HAILO_EXPORTING
        /wd4201                     # Anonymous union/struct
        /wd4251                     # C++ ABI with STL
    )
    add_definitions(-D_CRT_SECURE_NO_WARNINGS)  # Disable "unsafe function" warnings
elseif(UNIX)
    if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU" OR CMAKE_CXX_COMPILER_ID STREQUAL "QCC")
        set(HAILORT_COMPILE_OPTIONS ${HAILORT_COMPILE_OPTIONS} -Wall -Wextra -Wconversion)
    elseif(CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
        set(HAILORT_COMPILE_OPTIONS ${HAILORT_COMPILE_OPTIONS} -Wall -Wextra
            # TODO: remove me warnings
            -Wno-conversion
            -Wno-deprecated-declarations  # On c structures with deprecated attribute, clang generates implicit move ctor
                                          # that causes a warning
            -Wno-inconsistent-missing-override
            )
    else()
        message(FATAL_ERROR "Invalid value for CMAKE_CXX_COMPILER_ID: ${CMAKE_CXX_COMPILER_ID}")
    endif()
else()
    message(FATAL_ERROR "Unexpeced host, stopping build")
endif()

# Enable output of compile commands during generation
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

# Add subdirectories
add_subdirectory(hailort)

=== hailort/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5.0)

option(HAILO_BUILD_EMULATOR "Build hailort for emulator" OFF)
option(HAILO_BUILD_UT "Build Unit Tests" OFF)
option(HAILO_INTERNAL_BUILD "Build internal hailort componments" OFF)
option(HAILO_BUILD_TOOLS "Build tools" OFF)
option(HAILO_BUILD_GSTREAMER "Compile gstreamer plugins" OFF)
option(HAILO_BUILD_EXAMPLES "Build examples" OFF)
option(HAILO_OFFLINE_COMPILATION "Don't download external dependencies" OFF)
option(HAILO_COMPILE_WARNING_AS_ERROR "Add compilation flag for treating compilation warnings as errors" OFF)
option(HAILO_SUPPORT_PACKAGING "Create HailoRT package (internal)" OFF)
option(HAILO_BUILD_DOC "Build doc" OFF)
option(HAILO_BUILD_HX18 "Build HX18" OFF)
option(ENABLE_PERFETTO "Build with Perfetto tracing support" OFF)
option(HAILO_BUILD_HAILORT_SERVER "Build Hailort Server" OFF)
option(HAILO_BUILD_GENAI_SERVER "Build GenAI Server" OFF)

if (HAILO_COMPILE_WARNING_AS_ERROR)
    if(WIN32)
        set(HAILORT_COMPILE_OPTIONS ${HAILORT_COMPILE_OPTIONS} /WX)
    elseif(UNIX)
        set(HAILORT_COMPILE_OPTIONS ${HAILORT_COMPILE_OPTIONS} -Werror)
    else()
        message(FATAL_ERROR "Unexpeced host, stopping build")
    endif()
endif()

# Flag for emulator (FPGA/Veloce)
if(HAILO_BUILD_EMULATOR)
    message(WARNING "HailoRT is building with Emulator flag on")
    set(HAILORT_COMPILE_OPTIONS ${HAILORT_COMPILE_OPTIONS} -DHAILO_EMULATOR)
endif()

# Set firmware version
add_definitions( -DFIRMWARE_VERSION_MAJOR=5 )
add_definitions( -DFIRMWARE_VERSION_MINOR=1 )
add_definitions( -DFIRMWARE_VERSION_REVISION=1 )

# TODO: temporary hack to support offline builds. Remove HAILO_OFFLINE_COMPILATION and use FETCHCONTENT_FULLY_DISCONNECTED
if(HAILO_OFFLINE_COMPILATION)
    set(FETCHCONTENT_FULLY_DISCONNECTED ON CACHE INTERNAL "")
    set(HAILO_OFFLINE_COMPILATION OFF CACHE INTERNAL "")
endif()

# TODO: move protobuf and grpc to inner cmake files
set(HAILO_EXTERNAL_DIR ${CMAKE_CURRENT_LIST_DIR}/external)
set(HAILO_EXTERNALS_CMAKE_SCRIPTS ${CMAKE_CURRENT_LIST_DIR}/cmake/external/)
include(${HAILO_EXTERNALS_CMAKE_SCRIPTS}/protobuf.cmake)

set(HAILORT_INC_DIR ${PROJECT_SOURCE_DIR}/hailort/libhailort/include)
set(HAILORT_SRC_DIR ${PROJECT_SOURCE_DIR}/hailort/libhailort/src)
set(HAILORT_COMMON_DIR ${PROJECT_SOURCE_DIR}/hailort/)
set(COMMON_INC_DIR ${PROJECT_SOURCE_DIR}/common/include)
set(DRIVER_INC_DIR ${PROJECT_SOURCE_DIR}/hailort/drivers/common)
set(RPC_DIR ${PROJECT_SOURCE_DIR}/hailort/rpc)
set(HRPC_DIR ${PROJECT_SOURCE_DIR}/hailort/hrpc)
set(HRPC_PROTOCOL_DIR ${PROJECT_SOURCE_DIR}/hailort/hrpc_protocol)
set(HAILORT_GENAI_DIR ${HAILORT_SRC_DIR}/genai)
set(HAILORT_TOKENIZER_DIR ${PROJECT_SOURCE_DIR}/hailort/common/genai/tokenizer)

add_subdirectory(common)
add_subdirectory(hrpc)
add_subdirectory(hrpc_protocol)
add_subdirectory(libhailort)
add_subdirectory(hailortcli)

if(HAILO_BUILD_HAILORT_SERVER OR HAILO_BUILD_GENAI_SERVER)
    add_subdirectory(hailort_server)
endif()

if(HAILO_INTERNAL_BUILD)
    add_subdirectory(internals)
endif()
if(HAILO_BUILD_TOOLS)
    add_subdirectory(tools)
endif()

if(HAILO_WIN_DRIVER)
    add_subdirectory(drivers/win)
endif()

if(HAILO_SUPPORT_PACKAGING)
    add_subdirectory(packaging)
endif()

# Compile PCIe Driver if QNX
if(CMAKE_SYSTEM_NAME STREQUAL QNX)
    add_subdirectory(drivers/qnx)
endif()

=== hailort/common/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5.0)

include(${HAILO_EXTERNALS_CMAKE_SCRIPTS}/spdlog.cmake)
include(${HAILO_EXTERNALS_CMAKE_SCRIPTS}/readerwriterqueue.cmake)
include(${HAILO_EXTERNALS_CMAKE_SCRIPTS}/xxhash.cmake)
include(${CMAKE_CURRENT_SOURCE_DIR}/../cmake/common_compiler_options.cmake)
include(${HAILO_EXTERNALS_CMAKE_SCRIPTS}/protobuf.cmake) # Required for genai serializer


set(HAILORT_COMMON_CPP_SOURCES
    ${CMAKE_CURRENT_SOURCE_DIR}/utils.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/barrier.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/file_utils.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/event_internal.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/fork_support.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/buffer_pool.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/genai/session_wrapper/session_wrapper.cpp

    ${CMAKE_CURRENT_SOURCE_DIR}/device_measurements.cpp
)

add_subdirectory(genai/serializer)
set(GENAI_SCHEME_CPP_SOURCES ${GENAI_SCHEME_CPP_SOURCES} PARENT_SCOPE)

if(WIN32)
    add_subdirectory(os/windows)
elseif(UNIX)
    add_subdirectory(os/posix)
else()
    message(FATAL_ERROR "Unexpeced host, stopping build")
endif()

# Create static library hailort_common
add_library(hailort_common STATIC ${HAILORT_COMMON_CPP_SOURCES})
target_include_directories(hailort_common
    PUBLIC
    $<BUILD_INTERFACE:${HAILORT_INC_DIR}>
    $<BUILD_INTERFACE:${HAILORT_COMMON_DIR}>
    $<BUILD_INTERFACE:${COMMON_INC_DIR}>
)

target_link_libraries(hailort_common
    PUBLIC
    spdlog::spdlog
    readerwriterqueue
    xxhash
)

if(CMAKE_SYSTEM_NAME STREQUAL QNX)
    include(${HAILO_EXTERNALS_CMAKE_SCRIPTS}/pevents.cmake)
    target_link_libraries(hailort_common PRIVATE pevents pci)
endif()

set_target_properties(hailort_common PROPERTIES
    CXX_STANDARD              17
    CXX_STANDARD_REQUIRED     YES
    CXX_EXTENSIONS            NO
    POSITION_INDEPENDENT_CODE ON
)

target_compile_options(hailort_common PRIVATE ${HAILORT_COMPILE_OPTIONS})
disable_exceptions(hailort_common)
exclude_archive_libs_symbols(hailort_common)


if(WIN32)
    target_link_libraries(hailort_common PRIVATE
        Ws2_32                  # Winsock2 API
        Iphlpapi                # IP Helper API (i.e GetIpNetTable)
        Shlwapi                 # Shell API (i.e PathIsDirectoryA)
    )
elseif(NOT CMAKE_SYSTEM_NAME STREQUAL Android)
    # TODO: HRT-14770 fix android build
    target_link_libraries(hailort_common PRIVATE
        rt                       # Used for shm api (i.e shm_open)
    )
endif()

=== hailort/hailort_server/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5.0)

set(THREADS_PREFER_PTHREAD_FLAG ON)
find_package(Threads REQUIRED)

set(HAILORT_SERVER_SOURCES
    hailort_server.cpp
    cng_buffer_pool.cpp
    ${HRPC_CPP_SOURCES}
    ${HRPC_PROTOCOL_CPP_SOURCES}
    ${DRIVER_OS_DIR}/driver_os_specific.cpp
    ${HAILORT_SRC_DIR}/vdma/pcie_session.cpp
    ${HAILORT_SRC_DIR}/vdma/memory/descriptor_list.cpp
    ${HAILORT_SRC_DIR}/vdma/memory/mapped_buffer.cpp
    ${HAILORT_SRC_DIR}/vdma/memory/dma_able_buffer.cpp
    ${HAILORT_SRC_DIR}/vdma/driver/hailort_driver.cpp
    ${HAILORT_SRC_DIR}/vdma/channel/interrupts_dispatcher.cpp
    ${HAILORT_SRC_DIR}/vdma/channel/transfer_launcher.cpp
    ${HAILORT_SRC_DIR}/vdma/channel/boundary_channel.cpp
    ${HAILORT_SRC_DIR}/vdma/channel/channels_group.cpp
    ${HAILORT_SRC_DIR}/vdma/channel/transfer_common.cpp
    ${HAILORT_SRC_DIR}/vdma/memory/continuous_buffer.cpp
    ${HAILORT_SRC_DIR}/utils/pool_allocator.cpp
    ${HAILORT_SRC_DIR}/utils/buffer_storage.cpp
)

if (HAILO_BUILD_GENAI_SERVER)
    if (WIN32)
        message(FATAL_ERROR "Compilation of GenAI Server is not supported on Windows")
    endif()

    include(${HAILO_EXTERNALS_CMAKE_SCRIPTS}/eigen.cmake)
    include(${HAILO_EXTERNALS_CMAKE_SCRIPTS}/tokenizers.cmake)
    include(${HAILO_EXTERNALS_CMAKE_SCRIPTS}/json.cmake)

    add_subdirectory(genai)
    list(APPEND HAILORT_SERVER_SOURCES
        ${GENAI_SCHEME_CPP_SOURCES}
        ${HAILORT_GENAI_SOURCES}
    )
endif()

add_executable(hailort_server ${HAILORT_SERVER_SOURCES} server_main.cpp)

target_include_directories(hailort_server PRIVATE
    ${HAILORT_SRC_DIR}
    ${COMMON_INC_DIR}
    ${DRIVER_INC_DIR}
)

target_compile_options(hailort_server PRIVATE ${HAILORT_COMPILE_OPTIONS})
set_property(TARGET hailort_server PROPERTY CXX_STANDARD 17)
set_property(TARGET hailort_server PROPERTY INSTALL_RPATH "$ORIGIN" "../lib/") # Link with a relative libhailort

target_link_libraries(hailort_server PRIVATE
    libhailort
    Threads::Threads
    rpc_proto
    hailort_common
)

if (HAILO_BUILD_GENAI_SERVER)
    target_include_directories(hailort_server PRIVATE
        ${HAILORT_GENAI_INCLUDE_DIR}
        ${HAILORT_TOKENIZER_DIR}
        ${CMAKE_CURRENT_SOURCE_DIR}
    )
    target_compile_definitions(hailort_server PRIVATE HAILO_GENAI_SERVER)

    target_link_libraries(hailort_server PRIVATE
        genai_scheme_proto
        tokenizers_cpp
        eigen
        nlohmann_json
    )
endif()

=== hailort/hailortcli/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5.0)

include(GNUInstallDirs)
include(${HAILO_EXTERNALS_CMAKE_SCRIPTS}/cli11.cmake)
include(${HAILO_EXTERNALS_CMAKE_SCRIPTS}/json.cmake)
include(${HAILO_EXTERNALS_CMAKE_SCRIPTS}/dotwriter.cmake)

# Include tokenizers when client tokenizer is enabled
if(HAILO_BUILD_CLIENT_TOKENIZER)
    include(${HAILO_EXTERNALS_CMAKE_SCRIPTS}/tokenizers.cmake)
endif()

set(HAILORTCLI_CPP_FILES
    hailortcli.cpp
    command.cpp
    scan_command.cpp
    run_command.cpp
    inference_progress.cpp
    power_measurement_command.cpp
    fw_control_command.cpp
    fw_update_command.cpp
    ssb_update_command.cpp
    infer_stats_printer.cpp
    sensor_config_command.cpp
    board_config_command.cpp
    fw_config_command.cpp
    fw_config_serializer.cpp
    common.cpp
    benchmark_command.cpp
    parse_hef_command.cpp
    memory_requirements_command.cpp
    graph_printer.cpp
    mon_command.cpp
    logs_command.cpp

    run2/run2_command.cpp
    run2/network_runner.cpp
    run2/live_stats.cpp
    run2/timer_live_track.cpp
    run2/network_live_track.cpp
    run2/measurement_live_track.cpp
    run2/io_wrappers.cpp
    download_action_list_command.cpp
    )

if(UNIX)
    # Unix only modules
    set(HAILORTCLI_CPP_FILES ${HAILORTCLI_CPP_FILES}
        measure_nnc_performance_command.cpp
        )
endif()

# 'config_definitions_json_file' is used in generate_definitions_json_str.in for configure_file()
file(READ "${PROJECT_SOURCE_DIR}/common/config_definitions.json" config_definitions_json_file)
set(config_definitions_header ${CMAKE_CURRENT_BINARY_DIR}/definitions_json.auto.hpp)
set(CONFIG_DEFENITIONS_IN ${PROJECT_SOURCE_DIR}/hailort/hailortcli/generate_definitions_json_str.in)
configure_file(${CONFIG_DEFENITIONS_IN} ${config_definitions_header})

add_executable(hailortcli
    ${config_definitions_header}
    ${HAILORTCLI_CPP_FILES}
    ${PROJECT_SOURCE_DIR}/common/src/firmware_header_utils.c
    ${PROJECT_SOURCE_DIR}/common/src/md5.c
    ${HAILORT_SRC_DIR}/net_flow/pipeline/pipeline.cpp # TODO: link dynamically with libhailort
)

target_compile_options(hailortcli PRIVATE ${HAILORT_COMPILE_OPTIONS})
set_property(TARGET hailortcli PROPERTY CXX_STANDARD 17)

# Link with a relative libhailort
set_property(TARGET hailortcli PROPERTY INSTALL_RPATH "$ORIGIN")
set_property(TARGET hailortcli APPEND PROPERTY INSTALL_RPATH "\$ORIGIN/../lib/")

target_link_libraries(hailortcli
    libhailort
    CLI11::CLI11
    nlohmann_json
    hailort_common
    eigen
    DotWriter
    scheduler_mon_proto
    profiler_proto)

if(HAILO_BUILD_CLIENT_TOKENIZER)
    target_link_libraries(hailortcli tokenizers_cpp)
endif()

if(WIN32)
    target_link_libraries(hailortcli winmm.lib) # Used for timeBeginPeriod, timeEndPeriod
endif()

target_include_directories(hailortcli
    PRIVATE
    ${CMAKE_CURRENT_BINARY_DIR} # CMAKE_CURRENT_BINARY_DIR is necessary for config_definitions_header
    ${HAILORT_COMMON_DIR}
    ${COMMON_INC_DIR}
    ${HAILORT_SRC_DIR}
)

install(TARGETS hailortcli
   RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
   CONFIGURATIONS Release
)
cli11_install_completion_file(hailortcli)

=== hailort/hrpc/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5.0)

set(RAW_CONN_IMPL_DIR "${CMAKE_CURRENT_SOURCE_DIR}/raw_connection_internal")

set(SRC_FILES
    ${CMAKE_CURRENT_SOURCE_DIR}/rpc_connection.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/hailo_session.cpp
    ${RAW_CONN_IMPL_DIR}/pcie/hailo_session_internal.cpp
    ${RAW_CONN_IMPL_DIR}/socket/hailo_session_internal.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/connection_context.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/client.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/server.cpp
)

set(HRPC_CPP_SOURCES ${SRC_FILES} PARENT_SCOPE)

set(THREADS_PREFER_PTHREAD_FLAG ON)
find_package(Threads REQUIRED)
add_library(hailo_rpc STATIC EXCLUDE_FROM_ALL ${SRC_FILES})
target_include_directories(hailo_rpc PRIVATE
    ${HAILORT_SRC_DIR}
    ${COMMON_INC_DIR}
    ${DRIVER_INC_DIR}
)
target_compile_options(hailo_rpc PRIVATE ${HAILORT_COMPILE_OPTIONS})
set_target_properties(hailo_rpc PROPERTIES CXX_STANDARD 17 POSITION_INDEPENDENT_CODE ON)
target_link_libraries(hailo_rpc PRIVATE
    Threads::Threads
    rpc_proto
    hailort_common
)

=== hailort/hrpc_protocol/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5.0)

protobuf_generate_cpp(PROTO_RPC_SRC PROTO_RPC_HEADER rpc.proto)
get_filename_component(PROTO_HEADER_DIRECTORY ${PROTO_RPC_HEADER} DIRECTORY)

add_library(rpc_proto STATIC EXCLUDE_FROM_ALL ${PROTO_RPC_SRC} ${PROTO_RPC_HEADER})
target_link_libraries(rpc_proto libprotobuf-lite)
set_target_properties(rpc_proto PROPERTIES CXX_STANDARD 17 GENERATED TRUE POSITION_INDEPENDENT_CODE ON)
if(CMAKE_HOST_WIN32)
    # https://github.com/protocolbuffers/protobuf/tree/master/cmake#notes-on-compiler-warnings
    target_compile_options(rpc_proto PRIVATE /wd4244)
endif()
get_filename_component(PROTO_HEADER_DIRECTORY ${PROTO_RPC_HEADER} DIRECTORY)
target_include_directories(rpc_proto
    PUBLIC
    $<BUILD_INTERFACE: ${PROTO_HEADER_DIRECTORY}>
    $<BUILD_INTERFACE: ${Protobuf_INCLUDE_DIRS}>
)

set(SRC_FILES
    ${CMAKE_CURRENT_SOURCE_DIR}/serializer.cpp
)

set(HRPC_PROTOCOL_CPP_SOURCES ${SRC_FILES} PARENT_SCOPE)

=== hailort/libhailort/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5.0)
# set(CMAKE_C_CLANG_TIDY "clang-tidy;-checks=*")

set(HAILORT_MAJOR_VERSION    5)
set(HAILORT_MINOR_VERSION    1)
set(HAILORT_REVISION_VERSION 1)

# Add the cmake folder so the modules there are found
set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH})

# Generate hef-proto files using host protobuf
protobuf_generate_cpp(PROTO_HEF_SRC PROTO_HEF_HEADER hef.proto)
protobuf_generate_python(PROTO_HEF_PY hef.proto) # TODO (HRT-12504): Copy hef_pb2.py to tools directory
protobuf_generate_python(PROTO_HEF_PY tracer_profiler.proto)

add_library(hef_proto ${PROTO_HEF_SRC} ${PROTO_HEF_HEADER} ${PROTO_HEF_PY})
target_link_libraries(hef_proto libprotobuf-lite)
set_target_properties(hef_proto PROPERTIES CXX_STANDARD 17 GENERATED TRUE POSITION_INDEPENDENT_CODE ON)
if(CMAKE_HOST_WIN32)
    # https://github.com/protocolbuffers/protobuf/tree/master/cmake#notes-on-compiler-warnings
    target_compile_options(hef_proto PRIVATE /wd4244)
endif()
get_filename_component(PROTO_HEADER_DIRECTORY ${PROTO_HEF_HEADER} DIRECTORY)
target_include_directories(hef_proto
    PUBLIC
    $<BUILD_INTERFACE: ${PROTO_HEADER_DIRECTORY}>
    $<BUILD_INTERFACE: ${Protobuf_INCLUDE_DIRS}>
)

protobuf_generate_cpp(PROTO_SCHEDULER_MON_SRC PROTO_SCHEDULER_MON_HEADR scheduler_mon.proto)
add_library(scheduler_mon_proto ${PROTO_SCHEDULER_MON_SRC} ${PROTO_SCHEDULER_MON_HEADR})
target_link_libraries(scheduler_mon_proto libprotobuf-lite)
set_target_properties(scheduler_mon_proto PROPERTIES CXX_STANDARD 17 GENERATED TRUE POSITION_INDEPENDENT_CODE ON)
if(CMAKE_HOST_WIN32)
    target_compile_options(scheduler_mon_proto PRIVATE /wd4244)
endif()
get_filename_component(PROTO_SCHEDULER_MON_HEADER_DIRECTORY ${PROTO_SCHEDULER_MON_HEADR} DIRECTORY)
target_include_directories(scheduler_mon_proto
    PUBLIC
    $<BUILD_INTERFACE: ${PROTO_SCHEDULER_MON_HEADER_DIRECTORY}>
    $<BUILD_INTERFACE: ${Protobuf_INCLUDE_DIRS}>
)

protobuf_generate_cpp(PROTO_PROFILER_SRC PROTO_PROFILER_HEADR tracer_profiler.proto)
add_library(profiler_proto ${PROTO_PROFILER_SRC} ${PROTO_PROFILER_HEADR})
target_link_libraries(profiler_proto libprotobuf-lite)
set_target_properties(profiler_proto PROPERTIES CXX_STANDARD 17 GENERATED TRUE POSITION_INDEPENDENT_CODE ON)
if(CMAKE_HOST_WIN32)
    target_compile_options(profiler_proto PRIVATE /wd4244)
endif()
get_filename_component(PROTO_PROFILER_HEADER_DIRECTORY ${PROTO_PROFILER_HEADR} DIRECTORY)
target_include_directories(profiler_proto
    PUBLIC
    $<BUILD_INTERFACE: ${PROTO_PROFILER_HEADER_DIRECTORY}>
    $<BUILD_INTERFACE: ${Protobuf_INCLUDE_DIRS}>
)

add_subdirectory(src)
set(NET_FLOW_INFRA_DIR "${CMAKE_CURRENT_SOURCE_DIR}/tests/infra/net_flow")

if(HAILO_BUILD_EXAMPLES)
    add_subdirectory(examples)
endif()
if(HAILO_BUILD_UT)
    add_subdirectory(tests)
endif()
add_subdirectory(bindings)
if(HAILO_BUILD_DOC)
    add_subdirectory(doc)
endif()

# Support builds without installation
set(HailoRT_DIR "${HailoRT_DIR}" PARENT_SCOPE)

=== hailort/prepare_externals/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5.0)
project(hailort_prebuild)

set(HAILO_EXTERNALS_EXCLUDE_TARGETS ON)

message("Downloading dependencies to ${HAILO_EXTERNAL_DIR} ...")
include(${CMAKE_CURRENT_LIST_DIR}/../cmake/external/pybind11.cmake)
include(${CMAKE_CURRENT_LIST_DIR}/../cmake/external/catch2.cmake)
include(${CMAKE_CURRENT_LIST_DIR}/../cmake/external/spdlog.cmake)
include(${CMAKE_CURRENT_LIST_DIR}/../cmake/external/json.cmake)
include(${CMAKE_CURRENT_LIST_DIR}/../cmake/external/cpp-httplib.cmake)
include(${CMAKE_CURRENT_LIST_DIR}/../cmake/external/dotwriter.cmake)
include(${CMAKE_CURRENT_LIST_DIR}/../cmake/external/benchmark.cmake)
include(${CMAKE_CURRENT_LIST_DIR}/../cmake/external/readerwriterqueue.cmake)
include(${CMAKE_CURRENT_LIST_DIR}/../cmake/external/xxhash.cmake)
include(${CMAKE_CURRENT_LIST_DIR}/../cmake/external/eigen.cmake)
include(${CMAKE_CURRENT_LIST_DIR}/../cmake/external/cli11.cmake)
include(${CMAKE_CURRENT_LIST_DIR}/../cmake/external/protobuf.cmake)
if(CMAKE_SYSTEM_NAME STREQUAL QNX)
    include(${CMAKE_CURRENT_LIST_DIR}/../cmake/external/pevents.cmake)
endif()
message("Finished downloading dependencies")

=== hailort/hailort_server/genai/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5.0)

set(HAILO_GENAI_SRC_DIR ${CMAKE_CURRENT_LIST_DIR})
set(HAILORT_GENAI_SERVER_COMPONENTS_SOURCES "")

add_subdirectory(llm)
add_subdirectory(vlm)
add_subdirectory(speech2text)

list(APPEND HAILORT_GENAI_SERVER_COMPONENTS_SOURCES
    ${HAILORT_TOKENIZER_DIR}/hailo_tokenizer.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/inference_manager.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/llm/llm_server.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/vlm/vlm_server.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/genai_server.cpp
)

set(HAILORT_GENAI_SOURCES
    ${HAILORT_GENAI_SERVER_COMPONENTS_SOURCES}
    ${HAILORT_GENAI_SPEECH2TEXT_COMPONENTS_SOURCES}
    PARENT_SCOPE
)

set(HAILORT_GENAI_INCLUDE_DIR ${CMAKE_CURRENT_SOURCE_DIR} PARENT_SCOPE)

=== hailort/libhailort/bindings/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5.0)

# QNX currently doesnt support GStreamer
if(HAILO_BUILD_GSTREAMER AND NOT CMAKE_SYSTEM_NAME STREQUAL QNX)
    add_subdirectory(gstreamer)
endif()

option(HAILO_BUILD_PYHAILORT_INTERNAL OFF)
if(HAILO_BUILD_PYHAILORT_INTERNAL)
    add_subdirectory(python/src/internal/)
endif()

=== hailort/libhailort/doc/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5.0)

find_package(Doxygen)
if(DOXYGEN_FOUND)
    set(DOXYGEN_OUTPUT_DIR ${CMAKE_CURRENT_BINARY_DIR}/doxygen)
    set(DOXYGEN_INDEX_FILE ${DOXYGEN_OUTPUT_DIR}/xml/index.xml)
    set(DOXYFILE_IN ${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in)
    set(DOXYFILE_OUT ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile)
    get_target_property(HAILORT_PUBLIC_HEADERS libhailort PUBLIC_HEADER)
    string (REPLACE ";" " " HAILORT_PUBLIC_HEADERS_SPACE_SEPARATED "${HAILORT_PUBLIC_HEADERS}")

    # Replace variables inside @@ with the current values
    configure_file(${DOXYFILE_IN} ${DOXYFILE_OUT} @ONLY)
    # Doxygen won't create this for us
    file(MAKE_DIRECTORY ${DOXYGEN_OUTPUT_DIR})

    # Only regenerate Doxygen when the Doxyfile or public headers change
    add_custom_command(OUTPUT ${DOXYGEN_INDEX_FILE}
                      DEPENDS ${HAILORT_PUBLIC_HEADERS}
                      COMMAND ${DOXYGEN_EXECUTABLE} ${DOXYFILE_OUT}
                      MAIN_DEPENDENCY ${DOXYFILE_OUT} ${DOXYFILE_IN}
                      COMMENT "Generating doc")

    add_custom_target(hailort_doxygen DEPENDS ${DOXYGEN_INDEX_FILE})

    install(
        DIRECTORY "${DOXYGEN_OUTPUT_DIR}" DESTINATION "doc/"
        CONFIGURATIONS Release)

    add_custom_target(doc ALL DEPENDS hailort_doxygen)

endif()

=== debian/changelog ===
h10-pyhailort (5.1.1-1) trixie; urgency=medium

  * Initial release.

 -- Serge Schneider <serge@raspberrypi.com>  Tue, 04 Nov 2025 14:44:16 +0000

=== debian/control ===
Source: h10-pyhailort
Section: libs
Priority: optional
Maintainer: Serge Schneider <serge@raspberrypi.com>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 dh-sequence-python3,
 cmake,
 h10-hailort (>= 5.1.1),
 python3-setuptools,
 python3-all,
 python3-dev,
 python3-pybind11,
 python3-verboselogs,
 python3-wheel,
Standards-Version: 4.6.2
Homepage: https://hailo.ai/
Vcs-Browser: https://github.com/hailo-ai/hailort/
Vcs-Git: https://github.com/hailo-ai/hailort.git

Package: python3-h10-hailort
Architecture: arm64
Depends:
 ${python3:Depends},
 ${misc:Depends},
 ${shlibs:Depends},
 h10-hailort (>= 5.1.1),
Provides: pyhailort
Conflicts: pyhailort, python3-hailort
Replaces: python3-hailort
Description: HailoRT Python API, which wraps the runtime library
 HailoRT is a lightweight, production-grade runtime library that runs on the
 host processor and provides a robust user-space library (the HailoRT Library)
 with intuitive APIs in C/C++ for optimized performance.
 .
 This package installs the library for Python 3.
